using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEditor;

public class TextureScroller : MonoBehaviour
{
  public float scrollSpeed;
  [TooltipAttribute("Degrees CCW from +Y")]
  public float scrollAngle;
  public AnimationCurve scrollSpeedCurve = AnimationCurve.Constant(0f, 1f, 1f);
  public AnimationCurve scrollAngleCurve = AnimationCurve.Constant(0f, 1f, 1f);
  public bool autoScroll;

  private Material material;

  void Awake() {
    material = GetComponent<MeshRenderer>().material;
  }

  void Update() {
    if (autoScroll) {
      ScrollMaterial(Time.deltaTime / 100f);
    }
  }

  void ScrollMaterial(float multiplier) {
    var angle = scrollAngle * scrollAngleCurve.Evaluate(Time.time);
    var magnitude = scrollSpeed * scrollSpeedCurve.Evaluate(Time.time) * multiplier;
    Vector2 offsetIncrement = Quaternion.Euler(0f, 0f, angle) * Vector3.up * magnitude;
    material.mainTextureOffset += offsetIncrement;
  }
}
